%define name bro-stunnel

Summary: stunnel configuration for bro-sshd (openssh-nersc)
Name: stunnel-bro
Version: 1.0
Release: 1.scs
License: GPLv2
Group: Applications/Internet
Source0: %{name}.conf
Source1: %{name}.init
BuildArch: noarch
Requires: stunnel
Requires(pre): stunnel
Buildroot: %{_tmppath}/stunnel-%{version}-%{release}-root

%description
Configuration and init script for stunnel for use with
Bro-instrumented sshd (e.g., openssh-nersc).

%install
rm -rf $RPM_BUILD_ROOT

%{__mkdir_p} $RPM_BUILD_ROOT%{_sysconfdir}/stunnel $RPM_BUILD_ROOT%{_sysconfdir}/init.d
touch $RPM_BUILD_ROOT%{_sysconfdir}/stunnel/%{name}.pem

%{__install} -m 0600 %{SOURCE0} $RPM_BUILD_ROOT%{_sysconfdir}/stunnel/
%{__install} -m 0755 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name}

%post
if [ ! -s %{_sysconfdir}/stunnel/%{name}.pem ]; then
    umask 0077
    cd %{_sysconfdir}/stunnel
    cat > %{name}.cfg <<-EOF
	[ req ]
	prompt = no
	distinguished_name = req_dn
	[ req_dn ]
	C=US
	ST=CA
	L=Berkeley
	O="Lawrence Berkeley National Laboratory"
	CN="`hostname`"
	EOF
    /usr/bin/openssl req -config %{name}.cfg -newkey rsa:1024 -keyout %{name}.key -nodes -x509 -days 3650 -out %{name}.crt >/dev/null 2>&1
    (cat %{name}.key ; echo ; cat %{name}.crt) > %{name}.pem
    rm -f %{name}.key %{name}.crt %{name}.cfg
fi
chmod go-rwx %{_sysconfdir}/stunnel/%{name}.pem
/sbin/chkconfig --add %{name} >/dev/null 2>&1 || :
/sbin/chkconfig %{name} on >/dev/null 2>&1 || :
/sbin/service %{name} start >/dev/null 2>&1 || :

%preun
if [ $1 -eq 0 ]; then
    /sbin/service %{name} stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del %{name} >/dev/null 2>&1 || :
fi

%postun
/sbin/service %{name} condrestart >/dev/null 2>&1 || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%attr(0600, root, root) %config(noreplace) %{_sysconfdir}/stunnel/%{name}.conf
%attr(0600, root, root) %config(noreplace) %{_sysconfdir}/stunnel/%{name}.pem
%{_sysconfdir}/init.d/%{name}

%changelog
